VERSION 5.00
Begin VB.UserControl MouseOut 
   BackStyle       =   0  'Transparent
   ClientHeight    =   1920
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3390
   Enabled         =   0   'False
   ScaleHeight     =   1920
   ScaleWidth      =   3390
   ToolboxBitmap   =   "MouseOut.ctx":0000
   Begin VB.PictureBox Capture 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   480
      Left            =   0
      Picture         =   "MouseOut.ctx":0312
      ScaleHeight     =   480
      ScaleWidth      =   960
      TabIndex        =   0
      Top             =   0
      Width           =   960
   End
End
Attribute VB_Name = "MouseOut"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'==================================================================================
'   Permet de simuler l'vnement MOUSE OUT sur les controls ayant un HWND
'
'   si vous trouvez un BUG ou que vous enrichisser cet OCX
'   merci de me faire parvenir vos amliorations et/ou commentaires
'
'   adresse en cours    : fred.just@free.fr
'   site actuel         : http://fred.just.free.fr/
'   adresse de secours  : fredjust@hotmail.com
'
'==================================================================================

Option Explicit


Type POINTAPI
    X As Long
    Y As Long
End Type

Dim Surveille As Control


Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" _
  (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
  
'Dclarations d'vnements:
Event MouseDown(Button As Integer, Shift As Integer)
Event MouseMove(Button As Integer, Shift As Integer, ByVal X As Single, ByVal Y As Single)
Event MouseUp(Button As Integer, Shift As Integer)
Event MouseOut()



'==================================================================================
'
'==================================================================================
Private Sub Capture_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift)
End Sub

'==================================================================================
'
'==================================================================================
Private Sub Capture_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim Xi, Yi As Single
Dim xyCursor As POINTAPI
    GetCursorPos xyCursor
    ScreenToClient Surveille.hwnd, xyCursor
        
    Xi = xyCursor.X * Screen.TwipsPerPixelX
    Yi = xyCursor.Y * Screen.TwipsPerPixelY
    
    If Xi < 0 Or Yi < 0 Or Xi > Surveille.Width Or Yi > Surveille.Height Then
          ReleaseCapture
          RaiseEvent MouseOut
    Else
        RaiseEvent MouseMove(Button, Shift, Xi, Yi)
    End If
End Sub

'==================================================================================
'
'==================================================================================
Public Sub LookFor(aControl As Variant)
    Set Surveille = aControl
    SetCapture Capture.hwnd
End Sub

'==================================================================================
'
'==================================================================================
Private Sub Capture_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift)
    SetCapture Capture.hwnd
End Sub

'==================================================================================
'
'==================================================================================
Private Sub UserControl_Resize()
    Width = Capture.ScaleWidth
    Height = Capture.ScaleHeight
End Sub

'==================================================================================
'
'==================================================================================
Public Sub ForceMouseOut()
    ReleaseCapture
    RaiseEvent MouseOut
End Sub
